module win32.objbase;

// Translated from Microsoft Platform SDK August 2001 Edition
// by Y.Tomino (demoonlit@inter7.jp)

import win32.wtypes;

// #include <rpc.h>
// #include <rpcndr.h>

// #if !defined( _OBJBASE_H_ )
// #define _OBJBASE_H_

// #if _MSC_VER > 1000
// #pragma once
// #endif

align(8):

// #ifdef _MAC
// #ifndef _WLM_NOFORCE_LIBS

// #ifdef _WLMDLL
//         #ifdef _DEBUG
// #...
// #...
//         #else
// #...
// #...
//         #endif
// #else
//         #ifdef _DEBUG
// #...
// #...
//         #else
// #...
// #...
//         #endif
// #...
// ...
// #endif

// #...

// #ifdef _DEBUG
// #...
// #...
// #else
// #...
// #...
// #endif

// #endif // !_WLM_NOFORCE_LIBS
// #endif // _MAC

// #ifdef _OLE32_
// #...
// #...
// #else

// #ifdef _68K_
// #ifndef REQUIRESAPPLEPASCAL
// #...
// #...
// #else
// #...
// #...
// #endif
// #else
// #define WINOLEAPI EXTERN_C DECLSPEC_IMPORT HRESULT STDAPICALLTYPE
// #define WINOLEAPI_(type) EXTERN_C DECLSPEC_IMPORT type STDAPICALLTYPE
// #endif

// #endif

// #if defined(__cplusplus) && !defined(CINTERFACE)

// #define interface struct
// #define STDMETHOD(method) virtual HRESULT STDMETHODCALLTYPE method
// #define STDMETHOD_(type,method) virtual type STDMETHODCALLTYPE method
// #define STDMETHODV(method) virtual HRESULT STDMETHODVCALLTYPE method
// #define STDMETHODV_(type,method) virtual type STDMETHODVCALLTYPE method
// #define PURE = 0
// #define THIS_
// #define THIS void
// #define DECLARE_INTERFACE(iface) interface DECLSPEC_NOVTABLE iface
// #define DECLARE_INTERFACE_(iface, baseiface) interface DECLSPEC_NOVTABLE iface : public baseiface

// #if !defined(BEGIN_INTERFACE)
// #if defined(_MPPC_)  && \
// ...
// #else
//    #define BEGIN_INTERFACE
//    #define END_INTERFACE
// #endif
// #endif

// #else

// #...

// #...
// #...
// #...
// #...

// #if !defined(BEGIN_INTERFACE)
// #if defined(_MPPC_)
// #...
// #...
// #else
// #...
// #...
// #endif
// #endif

// #...
// #...
// #...
// #ifdef CONST_VTABLE
// #...
// #...
// #...
// ...
// #else
// #...
// #...
// #...
// ...
// #endif
// #...

// #endif

// #ifndef FARSTRUCT
// #ifdef __cplusplus
// #define FARSTRUCT FAR
// #else
// #...
// #endif  // __cplusplus
// #endif  // FARSTRUCT

// #ifndef HUGEP
// #if defined(_WIN32) || defined(_MPPC_)
// #define HUGEP
// #else
// #...
// #endif // WIN32
// #endif // HUGEP

// #ifdef _MAC
// #if !defined(OLE2ANSI)
// #...
// #endif
// #endif

// #include <stdlib.h>

// #define LISet32(li, v) ((li).HighPart = ((LONG) (v)) < 0 ? -1 : 0, (li).LowPart = (v))

// #define ULISet32(li, v) ((li).HighPart = 0, (li).LowPart = (v))

enum : uint { CLSCTX_INPROC = CLSCTX_INPROC_SERVER|CLSCTX_INPROC_HANDLER }

// #if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM
enum : uint { CLSCTX_ALL = CLSCTX_INPROC_SERVER| CLSCTX_INPROC_HANDLER| CLSCTX_LOCAL_SERVER| CLSCTX_REMOTE_SERVER }

enum : uint { CLSCTX_SERVER = CLSCTX_INPROC_SERVER|CLSCTX_LOCAL_SERVER|CLSCTX_REMOTE_SERVER }
// #else
// #...
// ...

// #...
// #endif

alias int tagREGCLS;
enum {
  REGCLS_SINGLEUSE = 0,
  REGCLS_MULTIPLEUSE = 1,

  REGCLS_MULTI_SEPARATE = 2,

  REGCLS_SUSPENDED = 4,

  REGCLS_SURROGATE = 8,

}
alias tagREGCLS REGCLS;

enum : uint { MARSHALINTERFACE_MIN = 500 }

enum : uint { CWCSTORAGENAME = 32 }

enum : uint { STGM_DIRECT = 0x00000000 }
enum : uint { STGM_TRANSACTED = 0x00010000 }
enum : uint { STGM_SIMPLE = 0x08000000 }

enum : uint { STGM_READ = 0x00000000 }
enum : uint { STGM_WRITE = 0x00000001 }
enum : uint { STGM_READWRITE = 0x00000002 }

enum : uint { STGM_SHARE_DENY_NONE = 0x00000040 }
enum : uint { STGM_SHARE_DENY_READ = 0x00000030 }
enum : uint { STGM_SHARE_DENY_WRITE = 0x00000020 }
enum : uint { STGM_SHARE_EXCLUSIVE = 0x00000010 }

enum : uint { STGM_PRIORITY = 0x00040000 }
enum : uint { STGM_DELETEONRELEASE = 0x04000000 }
// #if (WINVER >= 400)
enum : uint { STGM_NOSCRATCH = 0x00100000 }
// #endif /* WINVER */

enum : uint { STGM_CREATE = 0x00001000 }
enum : uint { STGM_CONVERT = 0x00020000 }
enum : uint { STGM_FAILIFTHERE = 0x00000000 }

enum : uint { STGM_NOSNAPSHOT = 0x00200000 }
// #if (_WIN32_WINNT >= 0x0500)
enum : uint { STGM_DIRECT_SWMR = 0x00400000 }
// #endif

enum : uint { ASYNC_MODE_COMPATIBILITY = 0x00000001 }
enum : uint { ASYNC_MODE_DEFAULT = 0x00000000 }

enum : uint { STGTY_REPEAT = 0x00000100 }
enum : uint { STG_TOEND = 0xFFFFFFFF }

enum : uint { STG_LAYOUT_SEQUENTIAL = 0x00000000 }
enum : uint { STG_LAYOUT_INTERLEAVED = 0x00000001 }

enum : uint { STGFMT_STORAGE = 0 }
enum : uint { STGFMT_NATIVE = 1 }
enum : uint { STGFMT_FILE = 3 }
enum : uint { STGFMT_ANY = 4 }
enum : uint { STGFMT_DOCFILE = 5 }

enum : uint { STGFMT_DOCUMENT = 0 }

// typedef interface IRpcStubBuffer IRpcStubBuffer;
// typedef interface IRpcChannelBuffer IRpcChannelBuffer;

// #include <wtypes.h>
import win32.unknwn;
import win32.objidl;

// #ifdef _OLE32_
// #ifdef _OLE32PRIV_
// ...
// #...
// #else
// #...
// #endif  // _OLE32PRIV_
// #endif  // _OLE32_

import win32.guiddef;

// #ifndef INITGUID
import win32.cguid;
// #endif

alias int tagCOINIT;
enum {
  COINIT_APARTMENTTHREADED = 0x2,

// #if  (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM

  COINIT_MULTITHREADED = 0x0,
  COINIT_DISABLE_OLE1DDE = 0x4,
  COINIT_SPEED_OVER_MEMORY = 0x8,
// #endif // DCOM
}
alias tagCOINIT COINIT;

extern(Windows) export DWORD CoBuildVersion();

extern(Windows) export HRESULT CoInitialize(LPVOID pvReserved);
extern(Windows) export void CoUninitialize();
extern(Windows) export HRESULT CoGetMalloc(DWORD dwMemContext, LPMALLOC * ppMalloc);
extern(Windows) export DWORD CoGetCurrentProcess();
extern(Windows) export HRESULT CoRegisterMallocSpy(LPMALLOCSPY pMallocSpy);
extern(Windows) export HRESULT CoRevokeMallocSpy();
extern(Windows) export HRESULT CoCreateStandardMalloc(DWORD memctx, LPMALLOC * ppMalloc);

// #if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM
extern(Windows) export HRESULT CoInitializeEx(LPVOID pvReserved, DWORD dwCoInit);
extern(Windows) export HRESULT CoGetCallerTID(LPDWORD lpdwTID );
// #endif // DCOM

// #if DBG == 1
// ...
// #endif

extern(Windows) export HRESULT CoGetObjectContext(REFIID riid, LPVOID * ppv);

extern(Windows) export HRESULT CoGetClassObject(REFCLSID rclsid, DWORD dwClsContext, LPVOID pvReserved,
  REFIID riid, LPVOID * ppv);
extern(Windows) export HRESULT CoRegisterClassObject(REFCLSID rclsid, LPUNKNOWN pUnk,
  DWORD dwClsContext, DWORD flags, LPDWORD lpdwRegister);
extern(Windows) export HRESULT CoRevokeClassObject(DWORD dwRegister);
extern(Windows) export HRESULT CoResumeClassObjects();
extern(Windows) export HRESULT CoSuspendClassObjects();
extern(Windows) export ULONG CoAddRefServerProcess();
extern(Windows) export ULONG CoReleaseServerProcess();
extern(Windows) export HRESULT CoGetPSClsid(REFIID riid, CLSID *pClsid);
extern(Windows) export HRESULT CoRegisterPSClsid(REFIID riid, REFCLSID rclsid);

extern(Windows) export HRESULT CoRegisterSurrogate(LPSURROGATE pSurrogate);

extern(Windows) export HRESULT CoGetMarshalSizeMax(ULONG *pulSize, REFIID riid, LPUNKNOWN pUnk,
  DWORD dwDestContext, LPVOID pvDestContext, DWORD mshlflags);
extern(Windows) export HRESULT CoMarshalInterface(LPSTREAM pStm, REFIID riid, LPUNKNOWN pUnk,
  DWORD dwDestContext, LPVOID pvDestContext, DWORD mshlflags);
extern(Windows) export HRESULT CoUnmarshalInterface(LPSTREAM pStm, REFIID riid, LPVOID * ppv);
extern(Windows) export HRESULT CoMarshalHresult(LPSTREAM pstm, HRESULT hresult);
extern(Windows) export HRESULT CoUnmarshalHresult(LPSTREAM pstm, HRESULT * phresult);
extern(Windows) export HRESULT CoReleaseMarshalData(LPSTREAM pStm);
extern(Windows) export HRESULT CoDisconnectObject(LPUNKNOWN pUnk, DWORD dwReserved);
extern(Windows) export HRESULT CoLockObjectExternal(LPUNKNOWN pUnk, BOOL fLock, BOOL fLastUnlockReleases);
extern(Windows) export HRESULT CoGetStandardMarshal(REFIID riid, LPUNKNOWN pUnk,
  DWORD dwDestContext, LPVOID pvDestContext, DWORD mshlflags,
  LPMARSHAL * ppMarshal);

extern(Windows) export HRESULT CoGetStdMarshalEx(LPUNKNOWN pUnkOuter, DWORD smexflags,
  LPUNKNOWN * ppUnkInner);

alias int tagSTDMSHLFLAGS;
enum {
  SMEXF_SERVER = 0x01,
  SMEXF_HANDLER = 0x02,
}
alias tagSTDMSHLFLAGS STDMSHLFLAGS;

extern(Windows) export BOOL CoIsHandlerConnected( LPUNKNOWN pUnk);

extern(Windows) export HRESULT CoMarshalInterThreadInterfaceInStream(REFIID riid, LPUNKNOWN pUnk,
  LPSTREAM *ppStm);

extern(Windows) export HRESULT CoGetInterfaceAndReleaseStream(LPSTREAM pStm, REFIID iid,
  LPVOID * ppv);

extern(Windows) export HRESULT CoCreateFreeThreadedMarshaler(LPUNKNOWN punkOuter,
  LPUNKNOWN *ppunkMarshal);

extern(Windows) export HINSTANCE CoLoadLibrary( LPOLESTR lpszLibName,  BOOL bAutoFree);
extern(Windows) export void CoFreeLibrary( HINSTANCE hInst);
extern(Windows) export void CoFreeAllLibraries();
extern(Windows) export void CoFreeUnusedLibraries();
// #if  (_WIN32_WINNT >= 0x0501 )
extern(Windows) export void CoFreeUnusedLibrariesEx( DWORD dwUnloadDelay,  DWORD dwReserved);
// #endif

// #if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM

extern(Windows) export HRESULT CoInitializeSecurity(
  PSECURITY_DESCRIPTOR pSecDesc,
  LONG cAuthSvc,
  SOLE_AUTHENTICATION_SERVICE *asAuthSvc,
  void *pReserved1,
  DWORD dwAuthnLevel,
  DWORD dwImpLevel,
  void *pAuthList,
  DWORD dwCapabilities,
  void *pReserved3 );
extern(Windows) export HRESULT CoGetCallContext(REFIID riid, void **ppInterface );
extern(Windows) export HRESULT CoQueryProxyBlanket(
  LPUNKNOWN pProxy,
  DWORD *pwAuthnSvc,
  DWORD *pAuthzSvc,
  OLECHAR **pServerPrincName,
  DWORD *pAuthnLevel,
  DWORD *pImpLevel,
  RPC_AUTH_IDENTITY_HANDLE *pAuthInfo,
  DWORD *pCapabilites );
extern(Windows) export HRESULT CoSetProxyBlanket(
  LPUNKNOWN pProxy,
  DWORD dwAuthnSvc,
  DWORD dwAuthzSvc,
  OLECHAR *pServerPrincName,
  DWORD dwAuthnLevel,
  DWORD dwImpLevel,
  RPC_AUTH_IDENTITY_HANDLE pAuthInfo,
  DWORD dwCapabilities );
extern(Windows) export HRESULT CoCopyProxy(
  LPUNKNOWN pProxy,
  LPUNKNOWN *ppCopy );
extern(Windows) export HRESULT CoQueryClientBlanket(
  DWORD *pAuthnSvc,
  DWORD *pAuthzSvc,
  OLECHAR **pServerPrincName,
  DWORD *pAuthnLevel,
  DWORD *pImpLevel,
  RPC_AUTHZ_HANDLE *pPrivs,
  DWORD *pCapabilities );
extern(Windows) export HRESULT CoImpersonateClient();
extern(Windows) export HRESULT CoRevertToSelf();
extern(Windows) export HRESULT CoQueryAuthenticationServices(
  DWORD *pcAuthSvc,
  SOLE_AUTHENTICATION_SERVICE **asAuthSvc );
extern(Windows) export HRESULT CoSwitchCallContext(LPUNKNOWN pNewObject, LPUNKNOWN *ppOldObject );

enum : uint { COM_RIGHTS_EXECUTE = 1 }
enum : uint { COM_RIGHTS_SAFE_FOR_SCRIPTING = 2 }

// #endif // DCOM

extern(Windows) export HRESULT CoCreateInstance(REFCLSID rclsid, LPUNKNOWN pUnkOuter,
  DWORD dwClsContext, REFIID riid, LPVOID * ppv);

// #if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM

extern(Windows) export HRESULT CoGetInstanceFromFile(
  COSERVERINFO * pServerInfo,
  CLSID * pClsid,
  LPUNKNOWN punkOuter, // only relevant locally
  DWORD dwClsCtx,
  DWORD grfMode,
  OLECHAR * pwszName,
  DWORD dwCount,
  MULTI_QI * pResults );

extern(Windows) export HRESULT CoGetInstanceFromIStorage(
  COSERVERINFO * pServerInfo,
  CLSID * pClsid,
  LPUNKNOWN punkOuter, // only relevant locally
  DWORD dwClsCtx,
  LPSTORAGE pstg,
  DWORD dwCount,
  MULTI_QI * pResults );

extern(Windows) export HRESULT CoCreateInstanceEx(
  REFCLSID Clsid,
  LPUNKNOWN punkOuter, // only relevant locally
  DWORD dwClsCtx,
  COSERVERINFO * pServerInfo,
  DWORD dwCount,
  MULTI_QI * pResults );

// #endif // DCOM

// #if (_WIN32_WINNT >= 0x0500 ) || defined(_WIN32_DCOM) // DCOM

extern(Windows) export HRESULT CoGetCancelObject(DWORD dwThreadId, REFIID iid, void **ppUnk);
extern(Windows) export HRESULT CoSetCancelObject(LPUNKNOWN pUnk);
extern(Windows) export HRESULT CoCancelCall(DWORD dwThreadId, ULONG ulTimeout);
extern(Windows) export HRESULT CoTestCancel();
extern(Windows) export HRESULT CoEnableCallCancellation(LPVOID pReserved);
extern(Windows) export HRESULT CoDisableCallCancellation(LPVOID pReserved);

extern(Windows) export HRESULT CoAllowSetForegroundWindow(LPUNKNOWN pUnk, LPVOID lpvReserved);

extern(Windows) export HRESULT DcomChannelSetHResult(LPVOID pvReserved, ULONG* pulReserved, HRESULT appsHR);

// #endif

extern(Windows) export HRESULT StringFromCLSID(REFCLSID rclsid, LPOLESTR * lplpsz);
extern(Windows) export HRESULT CLSIDFromString(LPOLESTR lpsz, LPCLSID pclsid);
extern(Windows) export HRESULT StringFromIID(REFIID rclsid, LPOLESTR * lplpsz);
extern(Windows) export HRESULT IIDFromString(LPOLESTR lpsz, LPIID lpiid);
extern(Windows) export BOOL CoIsOle1Class( REFCLSID rclsid);
extern(Windows) export HRESULT ProgIDFromCLSID(REFCLSID clsid, LPOLESTR * lplpszProgID);
extern(Windows) export HRESULT CLSIDFromProgID(LPCOLESTR lpszProgID, LPCLSID lpclsid);
extern(Windows) export HRESULT CLSIDFromProgIDEx(LPCOLESTR lpszProgID, LPCLSID lpclsid);
extern(Windows) export int StringFromGUID2( REFGUID rguid,  LPOLESTR lpsz,  int cchMax);

extern(Windows) export HRESULT CoCreateGuid(GUID *pguid);

extern(Windows) export BOOL CoFileTimeToDosDateTime(
                  FILETIME * lpFileTime,  LPWORD lpDosDate,  LPWORD lpDosTime);
extern(Windows) export BOOL CoDosDateTimeToFileTime(
                        WORD nDosDate,  WORD nDosTime,  FILETIME * lpFileTime);
extern(Windows) export HRESULT CoFileTimeNow(FILETIME * lpFileTime );

extern(Windows) export HRESULT CoRegisterMessageFilter(LPMESSAGEFILTER lpMessageFilter,
  LPMESSAGEFILTER * lplpMessageFilter );

// #if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM
extern(Windows) export HRESULT CoRegisterChannelHook(REFGUID ExtensionUuid, LPCHANNELHOOK pChannelHook );
// #endif // DCOM

// #if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM

extern(Windows) export HRESULT CoWaitForMultipleHandles(DWORD dwFlags,
  DWORD dwTimeout,
  ULONG cHandles,
  LPHANDLE pHandles,
  LPDWORD lpdwindex);

alias int tagCOWAIT_FLAGS;
enum {
  COWAIT_WAITALL = 1,
  COWAIT_ALERTABLE = 2,
}
alias tagCOWAIT_FLAGS COWAIT_FLAGS;

// #endif // DCOM

extern(Windows) export HRESULT CoGetTreatAsClass(REFCLSID clsidOld, LPCLSID pClsidNew);
extern(Windows) export HRESULT CoTreatAsClass(REFCLSID clsidOld, REFCLSID clsidNew);

extern(Windows) alias HRESULT function(REFCLSID, REFIID, LPVOID *) LPFNGETCLASSOBJECT;

extern(Windows) alias HRESULT function() LPFNCANUNLOADNOW;

extern(Windows) export HRESULT DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID * ppv);

extern(Windows) export HRESULT DllCanUnloadNow();

extern(Windows) export LPVOID CoTaskMemAlloc( SIZE_T cb);
extern(Windows) export LPVOID CoTaskMemRealloc( LPVOID pv,  SIZE_T cb);
extern(Windows) export void CoTaskMemFree( LPVOID pv);

extern(Windows) export HRESULT CreateDataAdviseHolder(LPDATAADVISEHOLDER * ppDAHolder);

extern(Windows) export HRESULT CreateDataCache(LPUNKNOWN pUnkOuter, REFCLSID rclsid,
  REFIID iid, LPVOID * ppv);

extern(Windows) export HRESULT StgCreateDocfile(OLECHAR * pwcsName,
  DWORD grfMode,
  DWORD reserved,
  LPSTORAGE *ppstgOpen);

extern(Windows) export HRESULT StgCreateDocfileOnILockBytes(LPLOCKBYTES plkbyt,
  DWORD grfMode,
  DWORD reserved,
  LPSTORAGE *ppstgOpen);

extern(Windows) export HRESULT StgOpenStorage(OLECHAR * pwcsName,
  LPSTORAGE pstgPriority,
  DWORD grfMode,
  SNB snbExclude,
  DWORD reserved,
  LPSTORAGE *ppstgOpen);
extern(Windows) export HRESULT StgOpenStorageOnILockBytes(LPLOCKBYTES plkbyt,
  LPSTORAGE pstgPriority,
  DWORD grfMode,
  SNB snbExclude,
  DWORD reserved,
  LPSTORAGE *ppstgOpen);

extern(Windows) export HRESULT StgIsStorageFile(OLECHAR * pwcsName);
extern(Windows) export HRESULT StgIsStorageILockBytes(LPLOCKBYTES plkbyt);

extern(Windows) export HRESULT StgSetTimes(OLECHAR * lpszName,
  FILETIME * pctime,
  FILETIME * patime,
  FILETIME * pmtime);

extern(Windows) export HRESULT StgOpenAsyncDocfileOnIFillLockBytes(LPFILLLOCKBYTES pflb,
  DWORD grfMode,
  DWORD asyncFlags,
  LPSTORAGE *ppstgOpen);

extern(Windows) export HRESULT StgGetIFillLockBytesOnILockBytes(LPLOCKBYTES pilb,
  LPFILLLOCKBYTES *ppflb);

extern(Windows) export HRESULT StgGetIFillLockBytesOnFile(OLECHAR *pwcsName,
  LPFILLLOCKBYTES *ppflb);

extern(Windows) export HRESULT StgOpenLayoutDocfile(OLECHAR *pwcsDfName,
  DWORD grfMode,
  DWORD reserved,
  LPSTORAGE *ppstgOpen);

enum : uint { STGOPTIONS_VERSION = 2 }

struct tagSTGOPTIONS {
  USHORT usVersion;
  USHORT reserved;
  ULONG ulSectorSize;
  WCHAR* pwcsTemplateFile;
}
alias tagSTGOPTIONS STGOPTIONS;

extern(Windows) export HRESULT StgCreateStorageEx(WCHAR* pwcsName,
  DWORD grfMode,
  DWORD stgfmt, // enum
  DWORD grfAttrs, // reserved
  STGOPTIONS * pStgOptions,
  void * reserved,
  REFIID riid,
  void ** ppObjectOpen);

extern(Windows) export HRESULT StgOpenStorageEx(WCHAR* pwcsName,
  DWORD grfMode,
  DWORD stgfmt, // enum
  DWORD grfAttrs, // reserved
  STGOPTIONS * pStgOptions,
  void * reserved,
  REFIID riid,
  void ** ppObjectOpen);

extern(Windows) export HRESULT BindMoniker(LPMONIKER pmk, DWORD grfOpt, REFIID iidResult, LPVOID * ppvResult);

extern(Windows) export HRESULT CoInstall(
  LPBINDCTX pbc,
  DWORD dwFlags,
  uCLSSPEC * pClassSpec,
  QUERYCONTEXT * pQuery,
  LPWSTR pszCodeBase);

extern(Windows) export HRESULT CoGetObject(LPCWSTR pszName, BIND_OPTS *pBindOptions, REFIID riid, void **ppv);
extern(Windows) export HRESULT MkParseDisplayName(LPBC pbc, LPCOLESTR szUserName,
  ULONG * pchEaten, LPMONIKER * ppmk);
extern(Windows) export HRESULT MonikerRelativePathTo(LPMONIKER pmkSrc, LPMONIKER pmkDest, LPMONIKER
  * ppmkRelPath, BOOL dwReserved);
extern(Windows) export HRESULT MonikerCommonPrefixWith(LPMONIKER pmkThis, LPMONIKER pmkOther,
  LPMONIKER * ppmkCommon);
extern(Windows) export HRESULT CreateBindCtx(DWORD reserved, LPBC * ppbc);
extern(Windows) export HRESULT CreateGenericComposite(LPMONIKER pmkFirst, LPMONIKER pmkRest,
  LPMONIKER * ppmkComposite);
extern(Windows) export HRESULT GetClassFile(LPCOLESTR szFilename, CLSID * pclsid);

extern(Windows) export HRESULT CreateClassMoniker(REFCLSID rclsid, LPMONIKER * ppmk);

extern(Windows) export HRESULT CreateFileMoniker(LPCOLESTR lpszPathName, LPMONIKER * ppmk);

extern(Windows) export HRESULT CreateItemMoniker(LPCOLESTR lpszDelim, LPCOLESTR lpszItem,
  LPMONIKER * ppmk);
extern(Windows) export HRESULT CreateAntiMoniker(LPMONIKER * ppmk);
extern(Windows) export HRESULT CreatePointerMoniker(LPUNKNOWN punk, LPMONIKER * ppmk);
extern(Windows) export HRESULT CreateObjrefMoniker(LPUNKNOWN punk, LPMONIKER * ppmk);

extern(Windows) export HRESULT GetRunningObjectTable(DWORD reserved, LPRUNNINGOBJECTTABLE * pprot);

import win32.urlmon;
import win32.propidl;

extern(Windows) export HRESULT CreateStdProgressIndicator(HWND hwndParent,
  LPCOLESTR pszTitle,
  LPBINDSTATUSCALLBACK pIbscCaller,
  LPBINDSTATUSCALLBACK * ppIbsc);

// #ifndef RC_INVOKED
align:
// #endif // RC_INVOKED

// #endif     // __OBJBASE_H__
